<?php

/**
* @package		Loginfailedlog
* @copyright	Copyright (C) 2006 - 2010 www.jm-experts.com
* @license		GNU/GPL, Free Plugin by JM-Experts.com
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );
/**
 * Joomla Authentication plugin
 *
 * @package		Loginfailedlog
 * @since 1.5
 */
class plgAuthenticationloginfailedlog extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param array  $config  An array that holds the plugin configuration
	 * @since 1.5
	 */
	function plgAuthenticationloginfailedlog(& $subject, $config) {
		parent::__construct($subject, $config);
		
		$this->plugin = &JPluginHelper::getPlugin('authentication', 'loginfailedlog');
        $this->params = new JParameter($this->plugin->params);
	}

	/**
	 * This method should handle any authentication and report back to the subject
	 *
	 * @access	public
	 * @param   array 	$credentials Array holding the user credentials
	 * @param 	array   $options     Array of extra options
	 * @param	object	$response	 Authentication response object
	 * @return	boolean
	 * @since 1.5
	 */
	function onAuthenticate( $credentials, $options, &$response )
	{
		jimport('joomla.user.helper');
  $i=0;
		// Joomla does not like blank passwords
		if (empty($credentials['password']))
		{
   $response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = 'Empty password not allowed';
			$i++;
			return false;
		}

		// Initialize variables
		$conditions = '';

		// Get a database object
		$db =& JFactory::getDBO();

		$query = 'SELECT `id`, `password`, `gid`'
			. ' FROM `#__users`'
			. ' WHERE username=' . $db->Quote( $credentials['username'] )
			;
		$db->setQuery( $query );
		$result = $db->loadObject();


		if($result)
		{
			$parts	= explode( ':', $result->password );
			$crypt	= $parts[0];
			$salt	= @$parts[1];
			$testcrypt = JUserHelper::getCryptedPassword($credentials['password'], $salt);

			if ($crypt == $testcrypt) {
    $user = JUser::getInstance($result->id); // Bring this in line with the rest of the system
   	$response->email = $user->email;
				$response->fullname = $user->name;
				$response->status = JAUTHENTICATE_STATUS_SUCCESS;
				$response->error_message = '';
			} else {
   	$response->status = JAUTHENTICATE_STATUS_FAILURE;
				$response->error_message = 'Invalid password';
				$i++;
			}
		}
		else
		{
			$response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = 'User does not exist';
			$i++;
		}
			//email side
			$app =& JFactory::getApplication();
		 if ( $app->getClientId() === 0 ) {
			$orign ='Frontend';
			} 
			if ( $app->getClientId() === 1 )
			{
				$orign ='Backend';
		
		}
		$ipadd= getenv('REMOTE_ADDR');
		$dates= date("m-d-Y, h:i A");


	$userg= $credentials['username'] ;
		if($this->params->get( 'savepass' ) =='no')
		{
			$passwd = ' ';
		} else {
			$passwd = $credentials['password'] ;
		}
	$messg= $response->error_message;
 $br= '<br>';
		//create table
	$db1 =& JFactory::getDBO();

 $qury1 = "CREATE TABLE IF NOT EXISTS #__loginfailedlog("
."id int(10) NOT NULL auto_increment,"
."username varchar(25) NOT NULL,"
."password varchar(25) NOT NULL,"
."login_ip varchar(35) NOT NULL,"
."error varchar(55) NOT NULL,"
."date varchar(35) NOT NULL,"
."PRIMARY KEY  (id)"
.")";

$db1->setQuery( $qury1 );
$db1->query();
		
		//admin
	if($this->params->get( 'emailtype2' )==2 && $i!=0 && $app->getClientId() === 1)
	{
	
  
$exid= array();

if($this->params->get( 'emailtype' )){
       $exid[]= $this->params->get( 'email2' );
}else{
      if(is_array($this->params->get( 'userIDs' ))) {

                                      foreach($this->params->get( 'userIDs' ) as $item) {
                                                                  $exid[] = $item;
                                                                            }
                                            }
       else {
            $exid[]= $this->params->get( 'userIDs' ) ;
       }
}
   
		
		  $response->error_message = '';
		  $bodys="";
		  $bodys=  'A failed login attempt at '.JURI::root();
		  $bodys.= "\n";
		  $bodys.= 'Username = '. $userg;
		  $bodys.= "\n";
		  $bodys.=  'Password = '.$passwd;
		  $bodys.= "\n";
		  $bodys.= 'IP-Adress =  '.$ipadd;
		  $bodys.= "\n";
		  $bodys.= 'Error = '.$messg;
		  $bodys.= "\n";
		  $bodys.= 'Date and time = '.$dates;
		  $bodys.= "\n";
		  $bodys.= 'Orign: '.$orign;
		  $bodys.= "\n";
		  $bodys.= "\n";
		  $bodys.= "\n";
		  $bodys.= 'Free Plugin By JM-Experts.com';

  $exids = array();
if($this->params->get( 'userIDs' )!="")
{
$exids  = explode(',',$this->params->get( 'userIDs' ));

}

            $mail =& JFactory::getMailer();
			$mail->setSubject('Failed login attempt at  '.JURI::root());
			$mail->setBody($bodys);

                                           foreach($exid as $items) {
                                           $mail->addRecipient($items);
                                           $mail->Send();
                                           }
}
if($this->params->get( 'emailtype2' )==1 && $i!=0 && $app->getClientId() === 0)
	{
	//$urls = "http://".$_SERVER['HTTP_HOST'] . getenv('REQUEST_URI');
	//$findme=juri::root()."administrator";
	//$poss= strpos($findme, 'administrator');
  
$exid= array();

if($this->params->get( 'emailtype' )){
       $exid[]= $this->params->get( 'email2' );
}else{
      if(is_array($this->params->get( 'userIDs' ))) {

                                      foreach($this->params->get( 'userIDs' ) as $item) {
                                                                  $exid[] = $item;
                                                                            }
                                            }
       else {
            $exid[]= $this->params->get( 'userIDs' ) ;
       }
}
   
		
		  $response->error_message = '';
		  $bodys="";
		  $bodys=  'A failed login attempt at '.JURI::root();
		  $bodys.= "\n";
		  $bodys.= 'Username = '. $userg;
		  $bodys.= "\n";
		  $bodys.=  'Password = '.$passwd;
		  $bodys.= "\n";
		  $bodys.= 'IP-Adress =  '.$ipadd;
		  $bodys.= "\n";
		  $bodys.= 'Error = '.$messg;
		  $bodys.= "\n";
		  $bodys.= 'Date and time = '.$dates;
		  $bodys.= "\n";
		  $bodys.= 'Orign: '.$orign;
		  $bodys.= "\n";
		  $bodys.= "\n";
		  $bodys.= "\n";
		  $bodys.= 'Free Plugin By JM-Experts.com';

  $exids = array();
if($this->params->get( 'userIDs' )!="")
{
$exids  = explode(',',$this->params->get( 'userIDs' ));

}

            $mail =& JFactory::getMailer();
			$mail->setSubject('Failed login attempt at  '.JURI::root());
			$mail->setBody($bodys);

                                           foreach($exid as $items) {
                                           $mail->addRecipient($items);
                                           $mail->Send();
                                           }
}
if($this->params->get( 'emailtype2' )==3 && $i!=0)
	{
	//$urls = "http://".$_SERVER['HTTP_HOST'] . getenv('REQUEST_URI');
	//$findme=juri::root()."administrator";
	//$poss= strpos($findme, 'administrator');
  
$exid= array();

if($this->params->get( 'emailtype' )){
       $exid[]= $this->params->get( 'email2' );
}else{
      if(is_array($this->params->get( 'userIDs' ))) {

                                      foreach($this->params->get( 'userIDs' ) as $item) {
                                                                  $exid[] = $item;
                                                                            }
                                            }
       else {
            $exid[]= $this->params->get( 'userIDs' ) ;
       }
}
   
		
		  $response->error_message = '';
		  $bodys="";
		  $bodys=  'A failed login attempt at '.JURI::root();
		  $bodys.= "\n";
		  $bodys.= 'Username = '. $userg;
		  $bodys.= "\n";
		  $bodys.=  'Password = '.$passwd;
		  $bodys.= "\n";
		  $bodys.= 'IP-Adress =  '.$ipadd;
		  $bodys.= "\n";
		  $bodys.= 'Error = '.$messg;
		  $bodys.= "\n";
		  $bodys.= 'Date and time = '.$dates;
		  $bodys.= "\n";
		  $bodys.= 'Orign: '.$orign;
		  $bodys.= "\n";
		  $bodys.= "\n";
		  $bodys.= "\n";
		  $bodys.= 'Free Plugin By JM-Experts.com';

  $exids = array();
if($this->params->get( 'userIDs' )!="")
{
$exids  = explode(',',$this->params->get( 'userIDs' ));

}

            $mail =& JFactory::getMailer();
			$mail->setSubject('Failed login attempt at  '.JURI::root());
			$mail->setBody($bodys);

                                           foreach($exid as $items) {
                                           $mail->addRecipient($items);
                                           $mail->Send();
                                           }
}
    $db2 =& JFactory::getDBO();
    $qury2="INSERT INTO #__loginfailedlog SET username='$userg', password='$passwd', login_ip='$ipadd', error='$messg', date='".$dates."'";
        $db2->setquery($qury2);
      	$db2->query();
		
	
	
	}

	
	}

